<template>
  <b-card no-body>
    <template #header>
      <div class="d-flex">
        <div>
          <font-awesome-icon
            v-if="visible"
            class="collapse-control"
            icon="chevron-down"
            @click="visible = false"
          />
          <font-awesome-icon
            v-else-if="loading"
            icon="spinner"
            pulse
          />
          <font-awesome-icon
            v-else
            class="collapse-control"
            icon="chevron-right"
            @click="requestOpen"
          />
        </div>
        <div class="flex-grow-1 d-flex justify-content-between ml-2">
          <div>{{ filter.name }}</div>
          <span class="filter-description w-75 text-right">{{ filter.description }} </span>
        </div>
      </div>
    </template>
    <b-collapse
      v-if="enabledVersion"
      v-model="visible"
    >
      <base-editor
        v-model="enabledVersion.code"
        :filename="filter.name + '.py'"
        :header="false"
        read-only
      />
    </b-collapse>
  </b-card>
</template>

<script lang="ts">
import Vue from 'vue';

import { FilterVersion } from '@/common/types';
import BaseEditor from '@/components/BaseEditor.vue';
import { FilterService } from '@/api';

export default Vue.extend({
  components: {
    BaseEditor,
  },

  props: {
    filter: {
      required: true,
      type: Object,
    },
  },

  data() {
    return {
      enabledVersion: null as FilterVersion | null,
      loading: false,
      visible: false,
    };
  },

  methods: {
    async requestOpen() {
      if (!this.enabledVersion) {
        this.loading = true;
        const response = await FilterService.getEnabledVersion(this.filter.id);
        if (response) {
          this.enabledVersion = response.data;
        }
        this.loading = false;
      }
      this.visible = true;
    },
  },
});
</script>

<style scoped>
.filter-description {
  font-style: italic;
}
.collapse-control {
  cursor: pointer;
}
</style>
